;
;------------------*
; Textverarbeitung *
;      TEXV0       *
;alt 13.2.86       *
;30.8.86  H.Voelz  *
;15.9.86           *
;------------------*
        ORG     0C000H
;
CHRINZ  EQU     0E839H
VIDEO   EQU     0EB87H
SCAN    EQU     0E868H
AUSGB   EQU     0E7E4H
GETIY   EQU     0E1A2H
KBEF    EQU     0EFE6H
DATFEL  EQU     0EFF3H
AHEX    EQU     0E844H
ADROUT  EQU     0E83FH
ADRANZ  EQU     0E7BDH
CLS     EQU     0EB4BH
CRLF    EQU     0E830H
CHROUT  EQU     0E00CH
LINEIN  EQU     0E7F3H
CONVM   EQU     0E880H
;
;Speicherstellen
HIMEM1  EQU     0F000H
ZG      EQU     HIMEM1+11
EN1     EQU     ZG+1
EN2     EQU     EN1+2
EN3     EQU     EN2+2
STADR   EQU     EN3+2
ENADR   EQU     STADR+2
STZE    EQU     ENADR+2
MAZE    EQU     STZE+2
HIMEM   EQU     MAZE+2
LAEND   EQU     HIMEM+2
WERT    EQU     LAEND+11
;Texte
TABU    EQU     0DA7EH
AUSW    EQU     0DC5EH
FILEZ   EQU     0DBFCH
BITEXT  EQU     0DC03H
BYTFR   EQU     0DC14H
;
EOF     EQU     0FFH
;
;===========*
;   MAIN    *
;===========*
KALT    CALL    GETIY
;Sonderzeichen erzeugen
        LD      B,8
        LD      HL,TABU
UMLR    PUSH    BC
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      BC,8
        LDIR
        POP     BC
        DJNZ    UMLR-$
;Speicher Null setzen
        CALL    ABSTMA
        LD      (HL),0
        LD      DE,0
        LDIR
;Warmstart
WARM    LD      HL,AUSW
        CALL    AUSGB
        LD      HL,WARM
        PUSH    HL
WARM0   LD      DE,WARM0
        LD      HL,TABAU
        LD      B,4
;
;-----------------*
; Tabellensuche   *
;-----------------*
TABS    CALL    CHRINZ
        LD      (ZG),A
        CALL    VIDEO
        AND     0DFH
TABS0   CP      (HL)
        INC     HL
        JR      Z,TABSE-$
        INC     HL
        INC     HL
        DJNZ    TABS0-$
        LD      HL,KBEF
        CALL    AUSGB
        EX      DE,HL
        JP      (HL)
;
TABSE   LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        JP      (HL)
;Sprung zur Routine
;
;--------------------------*
;    Eingabe nach DE       *
;--------------------------*
ADEIN   CALL    AUSGB
        CALL    LINEIN
        PUSH    IY
        POP     HL
;
;------------------*
; tastet Buffer ab *
; gibt Wert nach DE*
;------------------*
CONV    CALL    CONVM
        RET     C
;
;------------------*
;   Fehleranzeige  *
;------------------*
ERROR   LD      HL,DATFEL
AUVIR   CALL    AUSGB
        CALL    CRLF
        OR      A
        RET
;
;--------------------------------------*
; Zeile eingeben, DE=Zeile, HL=Adresse *
;  Staradresse nach HL uebergeben      *
;--------------------------------------*
ZEIADR  LD      HL,-1
        PUSH    DE
ZEI1    XOR     A
ZEI2    CP      (HL)
        INC     HL
        JR      NZ,ZEI2-$
        LD      A,D
        OR      E
        DEC     DE
        JR      NZ,ZEI1-$
        POP     DE
        RET
;
;-------------------*
; HL:=BC; BC:=HL-BC *
;-------------------*
ADR1    PUSH    BC
        OR      A
        SBC     HL,BC
        LD      B,H
        LD      C,L
        POP     HL
        RET
;
ABSTMA  LD      HL,(HIMEM1)
        LD      DE,100H
        CALL    ABSTBC
        LD      HL,-1
        RET
;
;------------------------------*
;Zeigt ersten Teil vom File an *
;------------------------------*
FILANZ  CALL    CLS
        LD      (WERT),A
        LD      HL,FILEZ
        CALL    AUSGB
        LD      HL,(ENADR)
        PUSH    HL
        CALL    DEZANZ
        LD      HL,BITEXT
        CALL    AUSGB
        LD      HL,(HIMEM)
        POP     BC
        OR      A
        SBC     HL,BC
        CALL    DEZANZ
        XOR     A
        LD      (WERT),A
        LD      HL,BYTFR
        JP      AUSGB
;
;--------------------------------------*
; zeigt binaeren Wert in HL dezimal an *
; (WERT)=0  4-stellig  sonst 6-stellig *
;--------------------------------------*
DEZANZ  PUSH    BC
        PUSH    DE
        PUSH    HL
        XOR     A
        LD      D,A
        LD      B,16
ZYKD    ADD     HL,HL
        ADC     A,A
        DAA
        LD      E,A
        LD      A,D
        ADC     A,A
        DAA
        LD      D,A
        RL      C
        LD      A,E
        DJNZ    ZYKD-$
        LD      A,(WERT)
        OR      A
        JR      Z,STEL4-$
        LD      A,C
        CALL    AHEX
STEL4   CALL    ADROUT
        LD      A,32
        CALL    CHROUT
        POP     HL
        POP     DE
        POP     BC
        RET
;
;-------------------------------------*
;wandelt BCD in HL nach binaer in HL  *
;-------------------------------------*
DHEX    PUSH    HL
        LD      HL,0
        ADD     HL,SP
        XOR     A
        RRD
        PUSH    AF
        RRD
        PUSH    AF
        INC     HL
        RRD
        PUSH    AF
        RRD
        PUSH    AF
        LD      HL,0
        LD      B,4
ZYK     LD      E,L
        LD      D,H
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,DE
        ADD     HL,HL
        POP     DE
        LD      E,D
        LD      D,0
        ADD     HL,DE
        DJNZ    ZYK-$
        POP     DE
        RET
;
;----------------*
; BC:=HL-DE  >HL *
;----------------*
ABSTBC  OR      A
        SBC     HL,DE
        LD      B,H
        LD      C,L
        RET
;
;------------------*
;Laenge bin->Dez   *
;------------------*
SLAEN   LD      (LAEND),HL
        CALL    DHEX
        INC     HL
        LD      (IY+6EH),L
        LD      (IY+6DH),L
        RET
;
;----------------*
;Sucht nach File *
;----------------*
START   LD      HL,(HIMEM1)
        OR      A
        SBC     HL,DE
        LD      (HIMEM),HL
        LD      B,H
        LD      C,L
        LD      HL,0
        LD      A,EOF
        CPIR
        RET
;
;---------------*
;Ausgabe HL-> 0 *
;Eingabe Zeichen*
;nur gross      *
;---------------*
AUSEIN  CALL    AUSGB
        CALL    CHRINZ
        CALL    VIDEO
        RES     5,A
        PUSH    AF
        CALL    CRLF
        POP     AF
        RET
;
;-------------------------*
;Tabelle fuer Teilsysteme *
;-------------------------*
TABAU   DEFB    'T'
        DEFW    TEXOR
        DEFB    'S'
        DEFW    SORED
        DEFB    'F'
        DEFW    FILEX
        DEFB    1BH
        DEFW    0E003H
;

